/* CGBDEMO 'bar' ver 0.01 Copyright(C) 1999 BouKiChi */

#include <gb.h>
#include "barchr.c"

unsigned char attrdata[30];

void set_attr(void)
{
        unsigned char x,y;
        VBK_REG = 1; /* VRAM Bank = 1; */
        for(x=0; x < 20; x++) {  
                for(y=0; y < 18; y++) {
                        attrdata[y]=(x/4)&7;  
                }
                set_bkg_tiles(x,0,1,18,attrdata);
        }
        VBK_REG = 0; /* VRAM Bank = 0; */
}

void set_bkg(void)
{
        unsigned char x,y;
        set_bkg_data(0,4,barchr);
        for(x=0; x < 20; x++) {  
                for(y=0; y < 18; y++) {
                        attrdata[y]=(x&3);  
                }
                set_bkg_tiles(x,0,1,18,attrdata);
        }
        SHOW_BKG;
}

#define PALCALC(r,g,b) ((r&0x1F)|(((UWORD)g&0x1F)<<5)|(((UWORD)b&0x1F)<<10))

void main(void)
{
        unsigned char i,j,k,sw,x,y;
        unsigned long pal[4]={0x0000,0x0000,0x0000,0x0000};
        unsigned long tcnt;

        x=y=sw=tcnt=0;

        set_attr();
        set_bkg();

        for(i=0; i < 20; i+=4) {
           for(j=0; j < 4; j++) {
               pal[j]=PALCALC(0,0,(i+j));
           }
           set_bkg_palette( 7-((i/4)&7),1,&pal[0]);
        }

        while(1) {

                k=joypad();
                if (k & J_LEFT) {
                                x--; SCX_REG=x;
                }
                if (k & J_RIGHT) {
                                x++; SCX_REG=x;
                }
                if (k & J_DOWN) {
                                y++; SCY_REG=y;
                }
                if (k & J_UP) {
                                y--; SCY_REG=y;
                }
                if (k) wait_vbl_done(); 

                if (k & J_A && tcnt > 1000) {
                        for(i=0; i < 20; i+=4) {
                                for(j=0; j < 4; j++) {
                                        switch(sw) {
                                                case 0:
                                                  pal[j]=PALCALC(0x1F-(i+j),0,0);
                                                break;
                                                case 1:
                                                  pal[j]=PALCALC(0,0x1F-(i+j),0);
                                                break;
                                                case 2:
                                                  pal[j]=PALCALC(0,0,0x1F-(i+j));
                                                break;
                                                case 3:
                                                  pal[j]=PALCALC(0x1F-(i+j),
                                                                 0x1F-(i+j),
                                                                 0x1F-(i+j));
                                                break;
                                                case 4:
                                                  pal[j]=PALCALC((i+j),
                                                                 (i+j),
                                                                 (i+j));
                                                break;
                                                case 5:
                                                  pal[j]=PALCALC((i+j),
                                                                 0x00,
                                                                 0x1F);
                                                break;

                                        }

                                }  /* end of 'for(j...'*/
                                set_bkg_palette( 7-((i/4)&7),1,&pal[0]);
                        } /* end of for(i.... */
                        tcnt=0;
                        if (++sw > 5) sw=0;
                } /* end of if (k & J_A...  */
                tcnt++;

        } /* end of while(1); */
}
